## ros-foxy-rmw-implementation 1.0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rmw_implementation)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)
find_package(rmw_implementation_cmake REQUIRED)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

get_default_rmw_implementation(RMW_IMPLEMENTATION)

message(STATUS "")
message(STATUS "Default rmw implementation: '${RMW_IMPLEMENTATION}'")
message(STATUS "")

get_available_rmw_implementations(available_rmw_implementations)
list(LENGTH available_rmw_implementations count_available_rmw_implementations)
if(count_available_rmw_implementations EQUAL 1)
  set(rmw_implementation_disable_runtime_selection_default ON)
else()
  set(rmw_implementation_disable_runtime_selection_default OFF)
endif()

option(RMW_IMPLEMENTATION_DISABLE_RUNTIME_SELECTION "\
  Use only the RMW implementation specified at build time via the \
  'RMW_IMPLEMENTATION' environment variable and the 'RMW_IMPLEMENTATION' \
  CMake option, ignoring the runtime value of the 'RMW_IMPLEMENTATION' \
  environment variable"
  ${rmw_implementation_disable_runtime_selection_default})

if(RMW_IMPLEMENTATION_DISABLE_RUNTIME_SELECTION)
  message(STATUS "Runtime selection of RMW disabled; Only using "
    "'${RMW_IMPLEMENTATION}'")
else()
  message(STATUS "Runtime selection of RMW enabled")

  find_package(rcpputils REQUIRED)
  find_package(rcutils REQUIRED)
  find_package(rmw REQUIRED)

  add_library(${PROJECT_NAME} SHARED
    src/functions.cpp)
  ament_target_dependencies(${PROJECT_NAME}
    "rcpputils"
    "rcutils"
    "rmw")
  target_compile_definitions(${PROJECT_NAME}
    PUBLIC "DEFAULT_RMW_IMPLEMENTATION=${RMW_IMPLEMENTATION}")

  # Causes the visibility macros to use dllexport rather than dllimport,
  # which is appropriate when building the dll but not consuming it.
  target_compile_definitions(${PROJECT_NAME} PRIVATE "RMW_IMPLEMENTATION_BUILDING_DLL")

  if(BUILD_TESTING)
    # Causes symbols to be exposed for tests to use.
    target_compile_definitions(${PROJECT_NAME} PRIVATE
      "RMW_IMPLEMENTATION_DEFAULT_VISIBILITY=RMW_IMPLEMENTATION_PUBLIC")
  endif()

  configure_rmw_library(${PROJECT_NAME})

  ament_export_libraries(${PROJECT_NAME})
  ament_export_targets(${PROJECT_NAME})
  ament_export_dependencies(rcpputils rcutils)

  if(BUILD_TESTING)
    find_package(ament_cmake_gtest REQUIRED)
    ament_add_gtest(test_functions test/test_functions.cpp)
    ament_target_dependencies(test_functions rcutils rmw)
    target_link_libraries(test_functions ${PROJECT_NAME})

    find_package(performance_test_fixture REQUIRED)
    # Give cppcheck hints about macro definitions coming from outside this package
    get_target_property(ament_cmake_cppcheck_ADDITIONAL_INCLUDE_DIRS performance_test_fixture::performance_test_fixture INTERFACE_INCLUDE_DIRECTORIES)

    macro(benchmark_rmws)
      find_package(${rmw_implementation} REQUIRED)
      message(STATUS "Creating API tests for '${rmw_implementation}'")
      set(rmw_implementation_env_var RMW_IMPLEMENTATION=${rmw_implementation})

      add_performance_test(benchmark_symbols${target_suffix} test/benchmark/benchmark_symbols.cpp
        ENV ${rmw_implementation_env_var})
      if(TARGET benchmark_symbols${target_suffix})
        target_link_libraries(benchmark_symbols${target_suffix} ${PROJECT_NAME})
      endif()
    endmacro()
    call_for_each_rmw_implementation(benchmark_rmws)
  endif()

  install(
    TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
    RUNTIME DESTINATION bin
  )
endif()

register_rmw_implementation(
  "c:rosidl_typesupport_c"
  "cpp:rosidl_typesupport_cpp"
)

ament_package(
  CONFIG_EXTRAS "rmw_implementation-extras.cmake.in"
)

=== debian/changelog ===
ros-foxy-rmw-implementation (1.0.3-1focal) focal; urgency=high



 -- Alejandro Hernandez Cordero <alejandro@openrobotics.org>  Mon, 31 Jan 2022 08:00:00 -0000

ros-foxy-rmw-implementation (1.0.2-1focal) focal; urgency=high

  * Update quality declaration links (re: ros2/docs.ros2.org#52 <https://github.com/ros2/docs.ros2.org/issues/52>) (#184 <https://github.com/ros2/rmw_implementation/issues/184>)
  * Update QD to QL 1 (#167 <https://github.com/ros2/rmw_implementation/issues/167>)
  * Updated performance QD section (#153 <https://github.com/ros2/rmw_implementation/issues/153>)
  * Move the QD into the rmw_implementation subdirectory. (#111 <https://github.com/ros2/rmw_implementation/issues/111>)
  * Add nominal test for symbol prefetch() and unload. (#145 <https://github.com/ros2/rmw_implementation/issues/145>)
  * Added benchmark test to rmw_implementation (#127 <https://github.com/ros2/rmw_implementation/issues/127>)
  * Test load and lookup functionality. (#135 <https://github.com/ros2/rmw_implementation/issues/135>)
  * Contributors: Alejandro Hernández Cordero, Chris Lalancette, Michel Hidalgo, Scott K Logan, Simon Honigmann, Stephen Brawner

 -- Alejandro Hernandez Cordero <alejandro@openrobotics.org>  Wed, 14 Apr 2021 07:00:00 -0000

ros-foxy-rmw-implementation (1.0.1-1focal) focal; urgency=high

  * Foxy updated maintainers (#158 <https://github.com/ros2/rmw_implementation/issues/158>)
  * Contributors: Alejandro Hernández Cordero

 -- Alejandro Hernandez Cordero <alejandro@openrobotics.org>  Wed, 21 Oct 2020 07:00:00 -0000

ros-foxy-rmw-implementation (1.0.0-1focal) focal; urgency=high

  * Remove MANUAL_BY_NODE liveliness API (#101 <https://github.com/ros2/rmw_implementation/issues/101>)
  * Contributors: Ivan Santiago Paunovic

 -- Dirk Thomas <dthomas@osrfoundation.org>  Tue, 12 May 2020 07:00:00 -0000

ros-foxy-rmw-implementation (0.9.0-1focal) focal; urgency=high

  * Rename rosidl_message_bounds_t (#98 <https://github.com/ros2/rmw_implementation/issues/98>)
  * Adapt interfaces for service timestamps (#96 <https://github.com/ros2/rmw_implementation/issues/96>)
  * Add take_sequence to RMW API (#93 <https://github.com/ros2/rmw_implementation/issues/93>)
  * Export targets in addition to include directories / libraries (#97 <https://github.com/ros2/rmw_implementation/issues/97>)
  * Removed ament_cmake_python from package.xml (#95 <https://github.com/ros2/rmw_implementation/issues/95>)
  * Using get_env_var from rcpputils (#94 <https://github.com/ros2/rmw_implementation/issues/94>)
  * security-context -> enclave (#91 <https://github.com/ros2/rmw_implementation/issues/91>)
  * Fix dependency on rmw_implementation_cmake (#92 <https://github.com/ros2/rmw_implementation/issues/92>)
  * Removed poco dependency (#87 <https://github.com/ros2/rmw_implementation/issues/87>)
  * Use one participant per context API changes (#77 <https://github.com/ros2/rmw_implementation/issues/77>)
  * Add rmw_*_event_init() functions to rmw_implementation (#88 <https://github.com/ros2/rmw_implementation/issues/88>)
  * Moved rmw_implementation_cmake from depend to build_depend (#82 <https://github.com/ros2/rmw_implementation/issues/82>)
  * Removed python code (#85 <https://github.com/ros2/rmw_implementation/issues/85>)
  * Remove OpenSplice dependency (#79 <https://github.com/ros2/rmw_implementation/issues/79>)
  * Code style only: wrap after open parenthesis if not in one line (#78 <https://github.com/ros2/rmw_implementation/issues/78>)
  * Depend on rcpputils for find_library (#57 <https://github.com/ros2/rmw_implementation/issues/57>)
  * Added functions to get qos policies for publishers and subscribers to a topic (#72 <https://github.com/ros2/rmw_implementation/issues/72>)
  * Contributors: Alejandro Hernández Cordero, Dirk Thomas, Eric Cousineau, Ingo Lütkebohle, Ivan Santiago Paunovic, Jacob Perron, Jaison Titus, Miaofei Mei, Michael Carroll, Mikael Arguedas

 -- Dirk Thomas <dthomas@osrfoundation.org>  Sat, 25 Apr 2020 07:00:00 -0000

ros-foxy-rmw-implementation (0.8.2-1focal) focal; urgency=high

  * Add support for Cyclone DDS. (#71 <https://github.com/ros2/rmw_implementation/issues/71>)
  * Contributors: Ruffin

 -- Dirk Thomas <dthomas@osrfoundation.org>  Wed, 13 Nov 2019 08:00:00 -0000

ros-foxy-rmw-implementation (0.8.1-1focal) focal; urgency=high

  * use return_loaned_message_from (#76 <https://github.com/ros2/rmw_implementation/issues/76>)
  * Add localhost boolean parameter to create node function (#75 <https://github.com/ros2/rmw_implementation/issues/75>)
  * Zero copy api (#69 <https://github.com/ros2/rmw_implementation/issues/69>)
  * Add Python API for RMW implementation lookups (#73 <https://github.com/ros2/rmw_implementation/issues/73>)
  * update signature for added pub/sub options (#74 <https://github.com/ros2/rmw_implementation/issues/74>)
  * remove unneeded line from CMakeLists (#70 <https://github.com/ros2/rmw_implementation/issues/70>)
  * Make middleware selection more independent of build-time package availability (#67 <https://github.com/ros2/rmw_implementation/issues/67>)
  * Contributors: Brian Marchi, Dan Rose, Karsten Knese, Michel Hidalgo, William Woodall

 -- Dirk Thomas <dthomas@osrfoundation.org>  Wed, 23 Oct 2019 07:00:00 -0000

ros-foxy-rmw-implementation (0.8.0-1focal) focal; urgency=high

  * Add function for getting clients by node (#62 <https://github.com/ros2/rmw_implementation/issues/62>)
  * add get_actual_qos() feature to subscriptions (#61 <https://github.com/ros2/rmw_implementation/issues/61>)
  * Contributors: Jacob Perron, M. M

 -- Dirk Thomas <dthomas@osrfoundation.org>  Wed, 25 Sep 2019 07:00:00 -0000

ros-foxy-rmw-implementation (0.7.1-1focal) focal; urgency=high

  * add interfaces for rmw_take_event and assert_liveliness (#60 <https://github.com/ros2/rmw_implementation/issues/60>)
  * Rmw preallocate (#51 <https://github.com/ros2/rmw_implementation/issues/51>)
  * Contributors: Michael Carroll, Nick Burek



=== debian/control ===
Source: ros-foxy-rmw-implementation
Section: misc
Priority: optional
Maintainer: Alejandro Hernandez Cordero <alejandro@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake, ros-foxy-ament-cmake-gtest, ros-foxy-ament-lint-auto, ros-foxy-ament-lint-common, ros-foxy-performance-test-fixture, ros-foxy-rcpputils, ros-foxy-rcutils, ros-foxy-rmw, ros-foxy-rmw-connext-cpp, ros-foxy-rmw-cyclonedds-cpp, ros-foxy-rmw-fastrtps-cpp, ros-foxy-rmw-implementation-cmake, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-rmw-implementation
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-rcpputils, ros-foxy-rcutils, ros-foxy-rmw-implementation-cmake, ros-foxy-ros-workspace, ros-foxy-rmw-fastrtps-cpp | ros-foxy-rmw-connext-cpp
Description: The decision which ROS middleware implementation should be used for C++.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-rmw-implementation//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
